<!DOCTYPE html>
<html>

	<head>
		<title>Mapa de la memoria</title>
		<meta charset="utf-8" />
		<meta name="viewport" content="width=device-width, initial-scale=1" />
		<link rel="stylesheet" href="assets/css/main.css" />
		<link rel="stylesheet" href="assets/css/mapa.css" />
                <link href="//netdna.bootstrapcdn.com/font-awesome/3.2.1/css/font-awesome.css" rel="stylesheet">
                <link href='https://api.mapbox.com/mapbox-gl-js/v1.12.0/mapbox-gl.css' rel='stylesheet' />

		<!-- Scripts -->
			<script src="assets/js/jquery.min.js"></script>
			<script src="assets/js/jquery.scrolly.min.js"></script>
			<script src="assets/js/skel.min.js"></script>
			<script src="assets/js/util.js"></script>
			<script src="assets/js/main.js"></script>
                        <script src='https://api.mapbox.com/mapbox-gl-js/v1.12.0/mapbox-gl.js'></script>
                        <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.5.0/jquery.min.js"></script>
                        <script src='https://npmcdn.com/csv2geojson@latest/csv2geojson.js'></script>
                        <script src='https://npmcdn.com/@turf/turf/turf.min.js'></script>
	</head>

	<body>
		<!-- Header -->
			<header id="header">
				<a href="index.html" class="logo">Mapa <strong>de la memoria</strong></a>

				<nav>
					<a href="#menu">Menu</a>
				</nav>
			</header>

		<!-- Nav -->
			<nav id="menu">
				<ul class="links">
					<li><a href="index.html">Principal</a></li>
					<li><a href="proyecto.html">El proyecto</a></li>
					<li><a href="mapear.html">Mapear un sitio</a></li>
					<li><a href="mapa.html">Ver mapa</a></li>

				</ul>
			</nav>


  <nav id="menu-capas"></nav>
  <div id='map'></div>

  <script>

    var transformRequest = (url, resourceType) => {
      var isMapboxRequest =
        url.slice(8, 22) === "api.mapbox.com" ||
        url.slice(10, 26) === "tiles.mapbox.com";
      return {
        url: isMapboxRequest
          ? url.replace("?", "?pluginName=sheetMapper&")
          : url
      };
    };
    //YOUR TURN: add your Mapbox token 
    mapboxgl.accessToken = 'pk.eyJ1IjoiY3R5bmlrIiwiYSI6ImNrYzVnYWhteTA0emgyenFlbm5wcTdycHQifQ.ZGev0i_HerXEBNzYsYo9ag'; //Mapbox token 
    var map = new mapboxgl.Map({
      container: 'map', // container id
      style: 'mapbox://styles/mapbox/light-v10', //stylesheet location
      center: [-59.1356957,-37.3282887],  
      zoom: 6, 
      transformRequest: transformRequest
 
    });

    $(document).ready(function () {
      $.ajax({
        type: "GET",
        //YOUR TURN: Replace with csv export link
        url: 'https://docs.google.com/spreadsheets/d/16ivti1RNFI3bRoqO8G9weG4QJxkgDZRPKwo4Sa-DIK4/gviz/tq?tqx=out:csv&sheet=Memoria',
        dataType: "text",
        success: function (csvData) { makeGeoJSON(csvData); }
      });

      function makeGeoJSON(csvData) {
        csv2geojson.csv2geojson(csvData, {
          latfield: 'Latitud',
          lonfield: 'Longitud',
          delimiter: ','
        }, function (err, data) {
        map.on('load', function () {

//	map.loadImage(
//	'assets/iconos/marker-editor.png',
	// Add an image to use as a custom marker
//	function (error, image) {
//		if (error) throw error;
//		map.addImage('custom-marker', image);
//                   });

	    // disable map rotation using right click + drag
	    map.dragRotate.disable();
 
	    // disable map rotation using touch rotation gesture
	    map.touchZoomRotate.disableRotation();
	   
	   // Add zoom and rotation controls to the map.
	   map.addControl(new mapboxgl.NavigationControl(), 'top-left');

        //Add the the layer to the map 
    	map.addLayer({
              'id': 'csvData',
              'type': 'circle',
              'source': {
                'type': 'geojson',
                'data': data
              },
              'paint': {
                'circle-color': "blue",
            	'circle-radius': {
                	'base': 1.75,
                	'stops': [[12, 16], [22, 180]]
            		},
    		'circle-stroke-color': '#8dd3c7',
    		'circle-stroke-width': 3
	
              }
            });


	map.addSource('subzona12', {
  		type: 'geojson',
                data: 'assets/geojson/subzona12.geojson'
                });

	map.addSource('areastao', {
  		type: 'geojson',
                data: 'assets/geojson/areastao.geojson'
                });

	map.addSource('cabeceras', {
  		type: 'geojson',
                data: 'assets/geojson/cabeceras_areas.geojson'
                });

	map.addSource('calles', {
  		type: 'geojson',
                data: 'assets/geojson/calles.geojson'
                });

	map.addLayer({
		'id': 'Subzona 12',
		'type': 'fill',
		'source': 'subzona12',
		'layout': {},
		'paint': {
		'fill-color': '#088',
		'fill-opacity': 0.2
		}
	});

	map.addLayer({
		'id': 'Areas',
		'type': 'fill',
		'source': 'areastao',
		'layout': {},
		'paint': {
		'fill-color': '#555',
		'fill-opacity': 0.2
		}
	});

	map.addLayer({
		'id': 'Cabeceras',
		'type': 'symbol',
		'source': 'cabeceras',
		'layout': {
		'text-field': ['get', 'title'],
		'text-variable-anchor': ['top', 'bottom', 'left', 'right'],
		'text-radial-offset': 0.75,
		'text-justify': 'auto',
	//	'icon-image': 'custom-marker',
		'icon-allow-overlap': true
		}
	});


	map.addLayer({
		'id': 'Calles',
		'type': 'line',
		'source': 'calles',
		'layout': {
		'line-join': 'round',
		'line-cap': 'round'
		},
		'paint': {
		'line-color': '#888',
		'line-width': 5
		}
	});

	map.addLayer({
		'id': 'calles-nombres',
		'type': 'symbol',
		'source': 'calles',
		'layout': {
		'symbol-placement': 'line-center',
		'text-field': ['get', 'name']
		}
	});

	  map.addLayer({
		'id': 'sitios',
		'type': 'symbol',
		'source': 'csvData',
		'layout': {
		'text-field': [
			'match',
			['get', 'Marcas'],
			'SdM: Sitios de Memoria',
			'SdM',
			'CCD: Centros Clandestinos de Detención',
			'CCD',
			'CCDS: Centros Clandestinos de Detención Señalizados',
			'CCDS',
			'Pl: Placas',
			'Pl',
			'Mur: Murales',
			'Mur',
			'M: Monumentos',
			'M',
			'P: Pintadas',
			'P',
			'E: Esculturas',
			'E',
			'C: Cuadros',
			'C',
			'EP: Espacios Públicos',
			'EP',
			'HS: Hechos significativos',
			'HS',
			/* otros */ ' '
		],		
		'text-font': [
		'Open Sans Bold',
		'Arial Unicode MS Bold'
		],
		'text-size': 8
		},
		'minzoom': 8,
		'paint': {
		'text-color': 'white'
		}
	});

            // When a click event occurs on a feature in the csvData layer, open a popup at the
            // location of the feature, with description HTML from its properties.
            map.on('click', 'csvData', function (e) {
              var coordinates = e.features[0].geometry.coordinates.slice();

              //set popup text 
              //You can adjust the values of the popup to match the headers of your CSV. 
              // For example: e.features[0].properties.Name is retrieving information from the field Name in the original CSV. 
              var description = '<h3>' + e.features[0].properties.Nombre + '</h3>' +'<img src="'+e.features[0].properties.Imagen +'" width="230">' + '<h4>' + '<b>' + 'Dirección: ' + '</b>' + e.features[0].properties.Dirección + '</h4>' + '<h4>' + '<b>' + 'Localidad: ' + '</b>' + e.features[0].properties.Ciudad + '</h4>' + '<h4>' + '<b>' + 'Marcas: ' + '</b>' + e.features[0].properties.Marcas + '</h4>' + '<h4>' + '<center>' + '<a href="' + e.features[0].properties.Video + '" target="_blank" ><i class="fa fa-video-camera" aria-hidden="true"></i></a>' + '   ' + '<a href="' + e.features[0].properties.Fuente + '" target="_blank" ><i class="fa fa-link" aria-hidden="true"></i></a>' + '</h4>' + '</center>';
              // Ensure that if the map is zoomed out such that multiple
              // copies of the feature are visible, the popup appears
              // over the copy being pointed to.
              while (Math.abs(e.lngLat.lng - coordinates[0]) > 180) {f
                coordinates[0] += e.lngLat.lng > coordinates[0] ? 360 : -360;
              }
            if (e.features[0].properties.video == null || e.features[0].properties.video == undefined){
  		   console.log("El video es NULL o no está definido");
                }

	      if (e.features[0].properties.enlace == null || e.features[0].properties.enlace == undefined){
  		   console.log("El enlace es NULL o no está definido");
               }

       
           //add Popup to map

              new mapboxgl.Popup()
                .setLngLat(coordinates)
                .setHTML(description)
                .addTo(map);
            });


            // Change the cursor to a pointer when the mouse is over the places layer.
            map.on('mouseenter', 'csvData', function () {
              map.getCanvas().style.cursor = 'pointer';
            });

            // Change it back to a pointer when it leaves.
            map.on('mouseleave', 'places', function () {
              map.getCanvas().style.cursor = '';
            });

            var bbox = turf.bbox(data);
            map.fitBounds(bbox, { padding: 50 });

          });

        });
      };
 
   });


	// enumerate ids of the layers
	var toggleableLayerIds = ['Subzona 12', 'Areas','Calles'];
 
	// set up the corresponding toggle button for each layer
	for (var i = 0; i < toggleableLayerIds.length; i++) {
	var id = toggleableLayerIds[i];
 
	var link = document.createElement('a');
	link.href = '#';
	link.className = 'active';
	link.textContent = id;
 
	link.onclick = function (e) {
	var clickedLayer = this.textContent;
	e.preventDefault();
	e.stopPropagation();
 
	var visibility = map.getLayoutProperty(clickedLayer, 'visibility');
 
	// toggle layer visibility by changing the layout object's visibility property
	if (visibility === 'visible') {
		map.setLayoutProperty(clickedLayer, 'visibility', 'none');
		this.className = '';
	} else {
		this.className = 'active';
		map.setLayoutProperty(clickedLayer, 'visibility', 'visible');
	}
	};
 
	var layers = document.getElementById('menu-capas');
	layers.appendChild(link);
	}

        map.addControl(new mapboxgl.FullscreenControl(), 'top-left');

</script>

</body>

</html>
